//+------------------------------------------------------------------+
//|                                                   RSI_STO_Ve.mq4 |
//|                                                          Vetchio |
//|                                                vetchio@seznam.cz |
//+------------------------------------------------------------------+
#property copyright "Vetchio"
#property link      "vetchio@seznam.cz"

#property indicator_separate_window

#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Aqua
#property indicator_color3 Blue
#property indicator_color4 Blue


//---- input parameters
extern int       MA_Period=250;
extern int       MA_Method=1;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE,STYLE_DOT,1,Red);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,2,Aqua);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE,STYLE_DOT,1,Blue);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(3,DRAW_LINE,STYLE_DOT,1,Blue);
   SetIndexBuffer(3,ExtMapBuffer4);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   double dHigh , dLow , dResult;
   
//---- main loop
   for(int i=0; i<limit; i++)
     {
         dHigh = High[i];
         dLow = Low[i];
         dResult = dHigh - dLow;
         ExtMapBuffer1[i]= dResult ;
     }
     
   //----
   for(i=limit-1;i>=0;i--)
     {
        ExtMapBuffer2[i]= iMAOnArray(ExtMapBuffer1,0,MA_Period,0,MA_Method,i);
        ExtMapBuffer3[i]= ExtMapBuffer2[i] + iStdDevOnArray(ExtMapBuffer1,0,MA_Period,0,MA_Method,i);
        ExtMapBuffer4[i]= ExtMapBuffer2[i] - iStdDevOnArray(ExtMapBuffer1,0,MA_Period,0,MA_Method,i);
     }
  
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+